
Ruby - Bug #14232

Unused refinement still breaks method search

12/25/2017 12:34 PM - shugo (Shugo Maeda)

Status: Closed   

Priority: Normal   

Assignee: shugo (Shugo Maeda)   

Target version:    

ruby -v:  Backport: 2.3: DONTNEED, 2.4: DONE, 2.5:

DONE

Description

Given the following t.rb:

module A

  def foo

    puts "A#foo"

    super

  end

end

class B

  def foo

    puts "B#foo"

  end

end

class C < B

  include A

  def foo

    puts "C#foo"

    super

  end

end

module D

  refine A do

    def foo

    end

  end

end

C.new.foo

 Even if D is not used, B#foo cannot be called by super in A#foo:

$ ruby t.rb

C#foo

A#foo

Traceback (most recent call last):

        2: from t.rb:30:in `<main>'

        1: from t.rb:19:in `foo'

t.rb:4:in `foo': super: no superclass method `foo' for #<C:0x00005623950b74f8> (NoMethodError)

Associated revisions

Revision e973bde0d003ecec46c8f8946a50cf5120c17b60 - 12/26/2017 10:32 AM - nobu (Nobuyoshi Nakada)

vm_method.c: fix super in refined module

vm_method.c (rb_method_entry_complement_defined_class): clone

the original method entry of refined module instance method with

the active ICLASS, to track super method chain.
[ruby-dev:50390] [Bug #14232]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61484 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e973bde0 - 12/26/2017 10:32 AM - nobu (Nobuyoshi Nakada)

vm_method.c: fix super in refined module

vm_method.c (rb_method_entry_complement_defined_class): clone

the original method entry of refined module instance method with

the active ICLASS, to track super method chain.

[ruby-dev:50390] [Bug #14232]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61484 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3b3d4b6bf5ea028246a432c4a9874b755b1438a0 - 02/05/2018 02:21 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 61484: [Backport #14232]

    vm_method.c: fix super in refined module

    * vm_method.c (rb_method_entry_complement_defined_class): clone

      the original method entry of refined module instance method with

      the active ICLASS, to track super method chain.

      [ruby-dev:50390] [Bug #14232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@62234 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3b3d4b6b - 02/05/2018 02:21 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 61484: [Backport #14232]

    vm_method.c: fix super in refined module

    * vm_method.c (rb_method_entry_complement_defined_class): clone

      the original method entry of refined module instance method with

      the active ICLASS, to track super method chain.

      [ruby-dev:50390] [Bug #14232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@62234 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a7cef95f5cae8c6bba2a8eab6e3f906ab3c6c193 - 02/21/2018 06:16 AM - naruse (Yui NARUSE)

merge revision(s) 61484: [Backport #14232]

    vm_method.c: fix super in refined module

    * vm_method.c (rb_method_entry_complement_defined_class): clone

      the original method entry of refined module instance method with

      the active ICLASS, to track super method chain.

      [ruby-dev:50390] [Bug #14232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@62511 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision a7cef95f - 02/21/2018 06:16 AM - naruse (Yui NARUSE)

merge revision(s) 61484: [Backport #14232]

    vm_method.c: fix super in refined module

    * vm_method.c (rb_method_entry_complement_defined_class): clone

      the original method entry of refined module instance method with

      the active ICLASS, to track super method chain.

      [ruby-dev:50390] [Bug #14232]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@62511 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/26/2017 10:33 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

Applied in changeset trunk|r61484.
vm_method.c: fix super in refined module

vm_method.c (rb_method_entry_complement_defined_class): clone

the original method entry of refined module instance method with

the active ICLASS, to track super method chain.

[ruby-dev:50390] [Bug #14232]

#2 - 01/18/2018 04:39 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: REQUIRED, 2.4: REQUIRED, 2.5: REQUIRED

#3 - 01/18/2018 04:42 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: REQUIRED, 2.4: REQUIRED, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: REQUIRED, 2.5: REQUIRED

You cannot refine Module on 2.3.x.

I set DONTNEED for 2.3.

#4 - 02/05/2018 02:21 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: DONTNEED, 2.4: REQUIRED, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: DONE, 2.5: REQUIRED

ruby_2_4 r62234 merged revision(s) 61484.

#5 - 02/21/2018 06:16 AM - naruse (Yui NARUSE)

- Backport changed from 2.3: DONTNEED, 2.4: DONE, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: DONE, 2.5: DONE

ruby_2_5 r62511 merged revision(s) 61484.
